#!------------------------------------------------------------------------------------------
#! EntryFilter - Filter keystrokes in an entry or text control. 
#! (c) Copyright 2005 - 2007 John Christ, All Rights Reserved
#!
#! Version 1.02  2/22/2006
#!
#!------------------------------------------------------------------------------------------
#TEMPLATE (EntryFilter, 'EntryFilter v1.02'),FAMILY('CW20','ABC')
#EXTENSION (EntryFilterGlobal, 'EntryFilter Global Extension'),APPLICATION,LAST
#BOXED(''),AT(,,195)
#BUTTON('About EntryFilter Version 1.02'),AT(7,,189)
   #DISPLAY('EntryFilter Version 1.02 for Clarion'),AT(26,,,)
   #DISPLAY('32 bit only'),AT(55,,,)
   #DISPLAY('')
   #DISPLAY('Copyright (C) 2005 - 2007 by John Christ'),AT(29,,,)
   #DISPLAY('All Rights Reserved'),AT(50,,,)
   #DISPLAY('')
#ENDBUTTON
#ENDBOXED
#AT(%BeforeFileDeclarations)
! EntryFilter
EntryFilter_WM_CHAR      EQUATE(0102h)
EntryFilter_WM_NCDESTROY EQUATE(0082h)
EntryFilter_PropName     CSTRING('EntryFilter_OldWndProc')
#ENDAT
#AT(%GlobalMap)
! EntryFilter
MODULE('EntryFilter_win32.lib')
  EntryFilter_SetProp(ULONG, *CSTRING, ULONG), LONG, PROC, RAW, PASCAL, NAME('SetPropA')
  EntryFilter_GetProp(ULONG, *CSTRING), ULONG, RAW, PASCAL, NAME('GetPropA')
  EntryFilter_RemoveProp(ULONG, *CSTRING), ULONG, PROC, RAW, PASCAL, NAME('RemovePropA')
  EntryFilter_CallWindowProc(LONG, UNSIGNED, UNSIGNED, UNSIGNED, LONG), LONG, PASCAL, NAME('CallWindowProcA')
END
! EntryFilter
#ENDAT
#EXTENSION(EntryFilter, 'Filter keystrokes in an entry or text control'),REQ(EntryFilterGlobal),PROCEDURE,MULTI
#BOXED('Settings')
    #PROMPT('Entry Control:',FROM(%Control,(%ControlType = 'ENTRY' OR %ControlType = 'TEXT'))),%EntryControl,REQ
#ENDBOXED
#AT(%DataSectionBeforeWindow)
! EntryFilter
 MAP
%('EntryFilter_NewWndProc' & SLICE(%EntryControl, 2, LEN(%EntryControl))) PROCEDURE(UNSIGNED, UNSIGNED, UNSIGNED, LONG), LONG, PASCAL
 END
! EntryFilter
#ENDAT
#AT(%AfterWindowOpening)
#FIX(%Control,%EntryControl)
! EntryFilter
EntryFilter_SetProp(%EntryControl{PROP:Handle}, EntryFilter_PropName, %EntryControl{PROP:WndProc})
%EntryControl{PROP:WndProc} = ADDRESS(%('EntryFilter_NewWndProc' & SLICE(%EntryControl, 2, LEN(%EntryControl))))
! EntryFilter
#ENDAT
#AT(%LocalProcedures)
! EntryFilter
#FIX(%Control,%EntryControl)
%('EntryFilter_NewWndProc' & SLICE(%EntryControl, 2, LEN(%EntryControl))) PROCEDURE(UNSIGNED hWnd, UNSIGNED message, UNSIGNED wParam, LONG lParam)
EntryFilter_OldWndProc ULONG
  CODE
  EntryFilter_OldWndProc = EntryFilter_GetProp(hWnd, EntryFilter_PropName)
  CASE message
  OF EntryFilter_WM_CHAR
    CASE wParam
    #EMBED(%EntryFilterCaseCharacterCodeStatement, 'EntryFilter, CASE CharacterCode'),%EntryControl
    ELSE
      #EMBED(%EntryFilterCaseCharacterCodeElseStatement, 'EntryFilter, CASE CharacterCode ELSE'),%EntryControl
    END
  OF EntryFilter_WM_NCDESTROY
    EntryFilter_RemoveProp(hWnd, EntryFilter_PropName)
  END
  RETURN EntryFilter_CallWindowProc(EntryFilter_OldWndProc, hWnd, message, wParam, lParam)
! EntryFilter
#ENDAT